/**************************************************************************
**   yapoo 2010
**************************************************************************/
#include "backendthread.h"
#include <string.h>

//void InputBuffer::dataAvailable(){}
//InputBuffer::InputBuffer( QIODevice *in )
InputBuffer::InputBuffer( const char *inputFilename )
{
	filename_in.assign( inputFilename );

//	this->threshold = threshold;
	buff = new char[buffSize];
	pWrite = buff;
	pLimit = &buff[buffSize];

}
InputBuffer::~InputBuffer()
{
	delete[] buff;
}
/*
	int InputBuffer::read( char *p, int length )
	{
		mutex.lock();
		int actual_length, available_length;
		char *pEnd = pRead + length;

		if ( pRead <= pWrite )
		{
			if ( pEnd > pWrite )
			{
				pEnd = pWrite;
			}
			else if ( pEnd > pLimit )
			{
				pEnd = pLimit;
			}
		}
		else
		{
			if ( pEnd > pLimit )
			{
				pEnd = pLimit;
			}
		}

		actual_length = pEnd - pRead;
		::memcpy( p, pRead, actual_length );
		pRead += actual_length;
		if ( pRead == pLimit )
		{
			pRead = buff;
		}
		assert ( pRead < pLimit );
		mutex.unlock();
		return actual_length;
	}
*/

void InputBuffer::run()
{
	cerr << "InputBuffer start: thread_id:" <<  currentThreadId () << endl;

	int ret;
	infd = open( filename_in.c_str(), O_RDONLY | O_NONBLOCK );
	if ( infd == -1 )
	{
		cerr << "InputBuffer exit: open() failed: " << filename_in.c_str() << endl;
	}

	exitFlag = 0;
	do
	{
		msleep(1000/100);
		ret = read_in();
	} while (! exitFlag && !ret);

	close( infd );
		cerr << "InputBuffer end: thread_id:" <<  currentThreadId () << endl;
//	exec();
}


int InputBuffer::read_in()
{
	int sret;
	fd_set fds;
	struct timeval tv;
	{
		int ret;
		int size;
		size = pLimit - pWrite;
		size -= size % 188;
		if ( size > 188000 * 2 )
		{
			size = 188000 * 2;
		}
		ret = 0;
//		mutex.lock();
		do {
			FD_ZERO(&fds);
			FD_SET(infd, &fds);
			tv.tv_sec = 1;
			tv.tv_usec = 0;
			sret = select( infd + 1, &fds, NULL, NULL, &tv );
			if ( sret == -1 )
			{
				cerr << "select error " << __FILE__ << " " << __LINE__ << endl;
				return -1;
			}
			if ( sret == 0 )
			{
				cerr << "select 0 " << __FILE__ << " " << __LINE__ << endl;
				return 0;
			}
			ret = ::read( infd, pWrite, size );

			if ( ret < 0 )
			{
//				mutex.unlock();
				cout << __FILE__ << __LINE__ << endl;
				//					in->close();
				return -1;
			}
		/*
			if ( ret == 0 )
			{
				msleep( 100 );
			}
		*/
			size -= ret;

			pWrite += ret;
			if ( pWrite == pLimit )
			{
				pWrite = buff;
			}
//cout << "read_in:" << ret << endl;

		} while ( size && !exitFlag );
//		mutex.unlock();

	}
	return 0;
}

InputBuffer::Reader::Reader( InputBuffer* p )
{
	buff = p;
	pRead = p->pWrite;
	pLimit = p->pLimit;
}

int InputBuffer::Reader::read(char**pp, int length)
{
	int actual_length;
	*pp = pRead;

	char *pEnd = pRead + length;
	char *pWrite = buff->pWrite;

	if ( pRead <= pWrite )
	{
		if ( pEnd > pWrite )
		{
			pEnd = pWrite;
		}
		else if ( pEnd > pLimit )
		{
			pEnd = pLimit;
		}
	}
	else
	{
		if ( pEnd > pLimit )
		{
			pEnd = pLimit;
		}
	}

	actual_length = pEnd - pRead;
	actual_length -= actual_length % 188;

	pRead += actual_length;
	if ( pRead == pLimit )
	{
		pRead = buff->buff;
	}
	assert ( pRead < pLimit );
	return actual_length;
}
