/**************************************************************************
**   yapoo 2010
**************************************************************************/
#include "backendthread.h"
#include "errno.h"

PlayerThread::PlayerThread( InputBuffer *p,
							QProcess* playerProcess,
							const char *outputFile )
//							QIODevice *p2 )
{
	ts_id = -2;
	exitFlag = 0;
	inputBuffer = p;
	this->outputFile = outputFile;
	reader = new InputBuffer::Reader( p );
	this->playerProcess = playerProcess;
}


PlayerThread::~PlayerThread()
{
	if ( reader )
	{
		delete reader;
	}
}

void PlayerThread::run()
{
	start:
	int ret = 0;
	exitFlag = 0;

	cerr << "PlayerThread start: thread_id:" <<  currentThreadId () << endl;
	outfd = open( outputFile.c_str(), O_WRONLY );
//	cerr << "open fd:" << outfd <<endl;
	if ( outfd == -1 )
	{
		cerr << "PlayerThraead exit: open() failed: " << outputFile.c_str() << endl;
	}

/*
	ret = waitForTsChanged(2);
	if ( ret )
	{
		close( outfd );
		return;
	}
*/
	msleep( 500 );
	while ( !exitFlag && !ret )
	{
		ret = doOutput();
		msleep(1000/50);
	}

//	cerr << "PlayerThread: close outfd" << endl;
	close( outfd );
// cerr << "PlayerThread: exitFlag" << exitFlag << "ret" << ret << endl;

	if ( exitFlag == 2 )
	{
		goto start;
	}
cerr << "PlayerThread end: thread_id:" <<  currentThreadId () << endl;
}

int PlayerThread::waitForTsChanged( time_t wait_seconds )
{
//cerr << ts_id << endl;
	size_t ret;
	char *ts;
	TsHeadParser thp;
	time_t start_time = ::time( NULL );
	uint16_t new_id;
	do{
		ret = reader->read( &ts, 188 );
		if ( !ret )
		{
			msleep(100);
			continue;
		}
		thp.setPos( ts );
		assert( thp.syncOK() );
		if ( thp.pid() != 0 || !thp.isStart() )
		{
			continue;
		}
		new_id = (ts[3]<<8)|ts[4];
//cerr << new_id << endl;
		if (ts_id != new_id )
		{
			ts_id = new_id;
			return 0;
		}
	} while ( time(NULL) - start_time  < wait_seconds );
//cerr << "waitForTsChanged() timoed out" << endl;
//	return -1;
	return 0;
}

int PlayerThread::doOutput()
{
	int ret;
	qint64 size;
	char *p;

	ret = reader->read( &p, 188*100000 );

	if ( !ret )
	{
		msleep(100);
		return 0;
	}
//cerr << ret << endl;
//clearerr( fp_out );
	int sret;
	struct timeval tv;

	do
	{
		FD_ZERO(&wfds);
		FD_SET(outfd, &wfds);
		tv.tv_sec = 1;
		tv.tv_usec = 0;
		sret = select( outfd + 1, NULL, &wfds, NULL, &tv );
		if ( sret == -1 )
		{
cerr << "select" << strerror(errno) << endl;
			return -1;
		}
		if ( sret == 0 )
		{
cerr << __FILE__ << __LINE__ << endl;
			msleep( 10 );
			return 0;
		}
		size = ::write( outfd, p, ret );
/*
		if ( size == 0 )
		{
			msleep( 100 );
			continue;
		}
*/
		if ( size < 0 )
		{
cerr << __FILE__ << __LINE__ << endl;
			return -1;
		}

		ret -= size;
		if ( ret == 0 )
		{
			return 0;
		}
		assert ( ret > 0 );
		p += size;
	} while ( !exitFlag );
	return 0;
}
