/**************************************************************************
**   yapoo 2010
**************************************************************************/
#ifndef DESCRIPTOR_H
#define DESCRIPTOR_H

#include <stdint.h>

class Descriptor //: public Iterator<Descriptor>
{

	protected:
		const uint8_t *p;

	public:
		Descriptor() {}
		Descriptor( const uint8_t* pos ) { p = pos;}
		Descriptor( const Descriptor &d ) { p = d.p;}


		uint32_t descriptor_tag() { return p[0]; }
		uint32_t descriptor_length() { return p[1]; } // &p[2] からデスクリプタの最後まで

		uint32_t totalLength() { return descriptor_length() + 2; }
};

class ShortEventDescriptor : public Descriptor
{
	// tag 0x4D
	public:
		ShortEventDescriptor( const uint8_t* pos ) { p = pos;}

		const uint8_t *ISO_639_language_code() { return &p[2];/* 3 Bytes */ }
		uint8_t	event_name_length() { return ( p[5] );}
		const uint8_t *event_name_char() { return &p[6]; }
		uint8_t	text_length() { return ( p[6 + p[5] ] );}
		const uint8_t *text_char() { return &p[7 + event_name_length()]; }

};

#endif // DESCRIPTOR_H
