/**************************************************************************
**   yapoo 2010
**************************************************************************/
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

//#include <QMainWindow>
#include <QtGui>
#include <QDebug>
#include "backendthread.h"
#include "psisection.h"
#include <string>
using namespace std;

namespace Ui {
    class MainWindow;
}


class MainWindow : public QMainWindow {

    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();
	int setupConfig( const char *filename = 0 );

	Eit_PfInfoLocker infoLocker;

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;

	QString config_filename;
	QString player_name;
	QString recpt1_name;
	QStringList player_arg;
	QStringList recpt1_arg;
	QString fifo_dir;

	QString fifoname_in;
	QString fifoname_out;

	QProcess *inputProcess;
	InputBuffer *inputBuffer;
//	QFile *ptm_in;
	QProcess *playerProcess;
	PlayerThread *playerThread;
//	QFile *ptm_out
	string outputFilename;
	SiThread *siThread;
	Q_PID recpt1_pid;
//	string ptsname_out;
	int player_error_count;
	QTimer error_watch_timer;
	int current_prog;

	void startInput( const char *gr );
	void stopInput();
	void startPlayer( int tsprog = 0 );
	void stopPlayer();

	int readLine( QFile& file, QString& stringLine );
	void readConfig( QFile& file );

public slots:
	void cleanupTasks();

//	void onEit_PfChanged(Eit_PfInfoLocker* locker);
	void onEit_PfChanged();
	void onEit_pfViewCurrentItemChanged(QTreeWidgetItem* item, QTreeWidgetItem*);

	void onStateChanged ( QProcess::ProcessState){ cerr << "test" << endl;}
	void onChannelButtonClicked();
	void onProgramSelected(QTreeWidgetItem* pItem, int);
	void onPlayerStderrRecieved();
	void onPlayerCommandRecieved();

	void onInputProcessFinished( int exitCode, QProcess::ExitStatus exitStatus );
	void onPlayerProcessFinished( int exitCode, QProcess::ExitStatus exitStatus );
	void onErrorWatchTimerTimedOut() { player_error_count = 0; }
};

#endif // MAINWINDOW_H
